/**********************************************************************
  sR}h
  $Id: go_cmd.c,v 1.4 2002/03/02 16:44:02 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int	op_external_interrupt( struct MACHINE_RESOURCE *mres ) ;
int	op_decrement( struct MACHINE_RESOURCE *mres ) ;
int	op_single_step( struct MACHINE_RESOURCE *mres ) ;
int	chk_single_step( struct MACHINE_RESOURCE *mres ) ;
int	exception( struct MACHINE_RESOURCE *mres , int code ) ;

int	go_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int	excp ;
int	i,exec_num ;
int	break_flag ;
int     id ;
int     do_single_step ;
int     exec_mode ; 
static	int step_num=1 ;


 id=proc_list.cur_id ;
 break_flag=ON ;
 //݂pcbreak_ptƓꍇ͋^IɃu[N|Cg𖳌ɂ
 if( proc_list.proc[id].bp_num > 0 ){
   for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
     if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
       break_flag=OFF ;
       break ;
     }
   }
 }

 if( (mode & GO_STEP_MODE)==0 ){
   exec_num=-1 ;
 }else{
   if( tk_pt->pt[1]!=NULL ){
     exec_num=exatoi( tk_pt->pt[1] ) ;
     if( exec_num>0 ) step_num=exec_num ;
     else{
       fprintf(simmsgfp,"Invalid step number. range=1-%d\n",0x7fffffff) ;
       return(NORMAL_EXIT) ;
     }
   }
   exec_num=step_num ;
 }

 set_sighandl_ppcsim() ;
 while ( -1 ) {
   exec_mode=EXEC_INST ;

   if( sig_int != 0 ) break ;

   excp = op_decrement( &proc_list.proc[id] ) ; // occurd declement exception
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp) ;
     if( excp!=0 ) break ;
   }
   
   excp = op_external_interrupt( &proc_list.proc[id] ) ; // occurd declement exception
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp) ;
     if( excp!=0 ) break ;
   }
   
   if( break_flag==ON && proc_list.proc[id].bp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
	 break_flag=OFF ;
	 fprintf(simmsgfp,"Exec stop by break point.\n") ;
	 fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
		 proc_list.proc[id].pc,
		 proc_list.proc[id].inst) ;
	 return(NORMAL_EXIT) ;
       }
     }
   }
   
   if( proc_list.proc[id].pp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].pass_pt[i] ){
	 fprintf(simmsgfp,"Passed count= ") ;
	 printll(simmsgfp,iexe_count) ;
	 fprintf(simmsgfp,"\n") ;
	 switch( pp_msg ){
	 case PP_DUMP_PC :
	   exec_mode |= EXEC_DIS ;
	   break ;
	 case PP_DUMP_GPR :
	   print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
	   break ;
	 case PP_DUMP_ALL :
	   print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
	   break ;
	 default :
	 }
	 break ;
       }
     }
   }

   break_flag=ON ;

   trace_history[trace_ptr].pc   = proc_list.proc[id].pc ;
   trace_history[trace_ptr].inst = proc_list.proc[id].inst ;
   trace_ptr=(trace_ptr+1)%HISTORY_SIZE ;

   iexe_count++ ;

   if( trace_stat!=TRACE_OFF ){
     exec_mode |= EXEC_DIS ;
     switch( trace_stat ){
     case TRACE_GRP : 
       print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
       break ;
     case TRACE_ALL :
       print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
       break ;
     default :
     }
   }
   
   do_single_step=chk_single_step( &proc_list.proc[id] ) ;
   
   excp = op_exec( &proc_list.proc[id], exec_mode ) ;
   sim_io( &proc_list.proc[id] ) ;

   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp ) ;
     if( excp!=0 ){
       if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))==0 ){
	 fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	 	 proc_list.proc[id].pc,
	 	 proc_list.proc[id].inst) ;
       }
       break ;
     }
   }

   if( do_single_step==YES ){
     excp = op_single_step( &proc_list.proc[id] ) ; // occurd single step exception
     if( excp !=0 ){
       excp=exception( &proc_list.proc[id], excp ) ;
       if( excp!=0 ) break ;
     }
   }
   
   exec_num-- ;
   if( exec_num==0 ) break ;
   else if( exec_num<0 ) exec_num=-1 ;
 }

#ifdef SUPPORT_GRAPHIC_DEVICE
 SyncGdevDraw(&proc_list.proc[id]) ;
#endif

 return(NORMAL_EXIT) ;
}
